=== debian/changelog ===
cryptominisat5 (5.0.0+dfsg-1) unstable; urgency=low

  * First 5.0 release

 -- Mate Soos <soos.mate@gmail.com>  Tue, 28 Jun 2016 01:00:00 +0200
